
#include "Arduino.h" 
#include <ESP8266WiFi.h>

#include <ESPAsyncWebServer.h>
//#include <AsyncPrinter.h>
//#include <async_config.h>
//#include <DebugPrintMacros.h>
#include <ESPAsyncTCP.h>
#include <ESPAsyncTCPbuffer.h>
//#include <SyncClient.h>
//#include <tcp_axtls.h>


const char* ssid ="ON_AIR2020";
const char* password = "cGT>1_@?LOdBqD6kd%s@v|.b5x^4PD|?s}uu*j4o)Uqpa|r1jftH+H>8_oG6}v4";
const int PWM_output = 15;  // Lolin Pin D8
#define Led_Rouge 12 // Lolin pin  D6
#define Led_Bleue 2 // Lolin pin D4

IPAddress local_IP(192, 168, 0, 110);
// Set your Gateway IP address
IPAddress gateway(192, 168, 0, 254);
IPAddress subnet(255, 255, 0, 0);
IPAddress primaryDNS(212,27,40,241);   //optional
IPAddress secondaryDNS(212,27,40,240);   //optional

String sliderValue = "0";  // init value
String ConsigneValue = "0";
const char* PARAM_INPUT = "value";
const char* PARAM_INPUT1 ="value";
byte rssi_value;
unsigned int i,j,k;
unsigned int Compteur;
char RxBuffer[80];


// Create AsyncWebServer object on port 80
AsyncWebServer server(80);

const char index_html[] PROGMEM = R"rawliteral(
<!DOCTYPE HTML><html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>ESP Web Server</title>

  <style>
    html {font-family: Arial; display: inline-block; text-align: left;}
    h2 {font-size: 2.0rem;}
    h3 {font-size: 1.75rem;}
    h4 {font-size: 1.25rem;}
    h5 {font-size: 0.625rem;}

    p {font-size: 1.5rem;}
    body {max-width: 600px; max-height:400px   margin:40px auto; padding-bottom: 20px;}
    .slider { -webkit-appearance: none; margin: 14px; width: 360px; height: 25px; background: #FFD65C;
      outline: black; -webkit-transition: 1.6s; transition: opacity 0.6s;}
    .slider::-webkit-slider-thumb {-webkit-appearance: none; appearance: none; width: 35px; height: 35px; background: #003249; cursor: pointer;}
    .slider::-moz-range-thumb { width: 35px; height: 35px; background: #0F3249; cursor: pointer; } 
   
<br><br>
      body {max-width: 600px; max-height:400px   margin:10px auto; padding-bottom: 20px;}
    .consigne { -webkit-appearance: none; margin: 14px; width: 360px; height: 25px; background: red;
      outline: none; -webkit-transition: 0.6s; transition: opacity 2.6s;}
    .consigne::-webkit-slider-thumb {-webkit-appearance: none; appearance: none;width: 35px; height: 35px; background: #003249; cursor: pointer;}
    .consigne::-moz-range-thumb { width: 35px; height: 35px; background: #FF0000; cursor: pointer; } 
  </p><br>
 </style>


 <style>
.btn-group button 
{
  background-color: #04AA6D; /* Green  */
  border: 3px solid black;
  color: white; /* White text */
  padding: 10px 24px; /* Some padding */
  cursor: pointer; /* Pointer/hand icon */
  float: left; /* Float the buttons side by side */
}

/* Clear floats (clearfix hack) */
.btn-group:after 
{
  content: " ...... I/O ESP8266 ....... ";
  clear: both;
  display: table;
}

.btn-group button:not(:last-child)
 {
  border-right: none; /* Prevent double borders */
}

/* Add a background color on hover */
.btn-group button:hover 
{
  background-color: #080808 ;
}
  </style>

  <script>
function updateSliderPWM(element) {
  var sliderValue = document.getElementById("pwmSlider").value;
  document.getElementById("textSliderValue").innerHTML = sliderValue;
 // console.log(sliderValue);
  var xhr = new XMLHttpRequest();
  xhr.open("GET", "/slider?value="+sliderValue, true);
  xhr.send();
}
function updateConsigne(element) {
  var ConsigneValue = document.getElementById("consigne").value;
  document.getElementById("textConsigneValue").innerHTML =ConsigneValue;
 // console.log(Consigne);
  var xhr1 = new XMLHttpRequest();
  xhr1.open("GET", "/consigne?value="+ConsigneValue, true);
  xhr1.send();
}
 </script>
 
</head>
<body>

  <h2>ESP8266 Async. Web server </h2><br>
  <h5>ESP8266_Jaune_Slider_PWM_2021-0726.ino</h5>
  <br><br>
 
  <p><span id="textSliderValue">%SLIDERVALUE%</span></p>
  <p><input type="range" onchange="updateSliderPWM(this)" id="pwmSlider" max="1023" min="0"  value="%SLIDERVALUE%" step="1" class="slider"></p>
  
  <br>
  <p><span id="textConsigneValue">%CONSIGNEVALUE%</span></p>
  <p><input type="range" onchange="updateConsigne(this)" id="consigne" max="990" min="10"  value="%CONSIGNEVALUE%" step="1" class="consigne">  </p>

 <h1>Cde Sorties GPIO</h1>

<div class="btn-group">
  <button>Led Bleue</button>
  <button>Led Verte</button>
  <button>Led Rouge</button>
</div>

<br>
</body>
</html>
)rawliteral";

// Replaces placeholder with button section in your web page
String processor(const String& var)
{
 Serial.println(var);
  if ((var == "SLIDERVALUE") or (var == "CONSIGNEVALUE"))
  {
      Serial.println("Processor");
  if (var == "SLIDERVALUE")  return sliderValue;
  if (var == "CONSIGNEVALUE")     return ConsigneValue;
  }
  else
  return String();
}


// Replaces placeholder with button section in your web page
/*
String Bouttons(const String& var){
//  String processor(const String& var){
  //Serial.println(var);
  if(var == "BUTTONPLACEHOLDER"){
    String buttons = "";
    buttons += "<h4>Led Rouge GPIO 12</h4><label class=\"switch1\"><input type=\"checkbox\" onchange=\"toggleCheckbox(this)\" id=\"12\" " + outputState(12) + "><span class=\"slider1\"></span></label>";
    buttons += "<h4>Led_Bleue GPIO 02</h4><label class=\"switch2\"><input type=\"checkbox\" onchange=\"toggleCheckbox(this)\" id=\"2\" " + outputState(2) + "><span class=\"slider2\"></span></label>";
    return buttons;
  }
  return String();
}

String outputState(int output){
  if(digitalRead(output)){
    return "checked";
  }
  else {
    return "";
  }
}
*/

void setup(){
  // Serial port for debugging purposes
  Serial.begin(115200);
  delay(200);
  Serial.println();
  pinMode(Led_Bleue, OUTPUT);
  pinMode(Led_Rouge, OUTPUT);    // led rouge externe sur Lolin pin D6 (GPio 12)
  digitalWrite(Led_Rouge, LOW);
  // sortie PWM
  Serial.println(" ESP8266MOD Lolin NodeMCU Jaune 2x15 pins \r\n Test PWM rev 25/07/2021");
  Serial.println(" ESP8266_Jaune_Slider_PWM_2021-0726.ino");
  Serial.println(" Led Bleu in-built sur D4 (GPIO 2) pull up");
  Serial.println(" Led Rouge sur D6 (GPIO 12) pull Down");
  Serial.println(" Init PWM (GPIO 15)  => sortie sur Pin D8 module Lolin ");
  analogWriteRange(1023);
  analogWrite(PWM_output, sliderValue.toInt());  // Lolin pin D8
  analogWriteFreq(2000);
 
   // Configures static IP address
  if (!WiFi.config(local_IP, gateway, subnet, primaryDNS, secondaryDNS))
   {
    Serial.println("STA Failed to configure");
  } 
  // Connect to Wi-Fi
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi..");
  }
  // Print ESP Local IP Address
  Serial.println(WiFi.localIP());

  // Route for root / web page
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send_P(200, "text/html", index_html, processor);  
    });
 
  

 // Send a GET request to <ESP_IP>/slider?value=<inputMessage>
  server.on("/consigne", HTTP_GET, [] (AsyncWebServerRequest *request) 
    {
    String inputMessage;
    // GET input1 value on <ESP_IP>/consigne?value=<inputMessage>
    if (request->hasParam(PARAM_INPUT1)) {
      inputMessage = request->getParam(PARAM_INPUT1)->value();
      ConsigneValue = inputMessage;
     analogWrite(PWM_output, ConsigneValue.toInt());
    //  Serial.print( " Consigne=");Serial.println(inputMessage);
       }
    else {
      inputMessage = "No message sent";
    }
        Serial.print( " Consigne=");Serial.println(inputMessage);
       request->send(200, "text/plain", "OK");
  });

  // Send a GET request to <ESP_IP>/slider?value=<inputMessage>
  server.on("/slider", HTTP_GET, [] (AsyncWebServerRequest *request) {
    String inputMessage;
    // GET input value on <ESP_IP>/slider?value=<inputMessage>  
    if (request->hasParam(PARAM_INPUT))
      {
        inputMessage = request->getParam(PARAM_INPUT)->value();
        sliderValue = inputMessage;
        analogWrite(PWM_output, sliderValue.toInt());
      //   Serial.print( " Slider=");Serial.println(inputMessage);
       }
      else
       {
         inputMessage = "No message sent";
       }
       Serial.print( " Slider=");Serial.println(inputMessage);
       request->send(200, "text/plain", "OK");
      });

      // Send a GET request to <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
  /*
  server.on("/update", HTTP_GET, [] (AsyncWebServerRequest *request) {
    String inputMessage1;
    String inputMessage2;
    // GET input1 value on <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
    if (request->hasParam(PARAM_INPUT_1) && request->hasParam(PARAM_INPUT_2)) {
      inputMessage1 = request->getParam(PARAM_INPUT_1)->value();
      inputMessage2 = request->getParam(PARAM_INPUT_2)->value();
      digitalWrite(inputMessage1.toInt(), inputMessage2.toInt());
    }
    else {
      inputMessage1 = "No message sent";
      inputMessage2 = "No message sent";
    }
    Serial.print("GPIO: ");
    Serial.print(inputMessage1);
    Serial.print(" - Set to: ");
    Serial.println(inputMessage2);
    request->send(200, "text/plain", "OK");
  });
  */
    

  
  // Start server
  server.begin();
 

}
  
void loop() {
 // led sur module Lolin
    digitalWrite(Led_Bleue,HIGH);
    delay(500);
    digitalWrite(Led_Bleue,LOW);
    delay(500);
   
  //  Serial.readBytesUntil('\r',RxBuffer,32);
  // if (sizeof(RxBuffer)>0) Serial.println(RxBuffer);
}

/*




--------- sur terminal YAT 115200 bds  COM48 -----------
 Test PWM rev 22/07/2021
 ESP8266_Jaune_Slider_PWM_2021-0723.ino
 Led Rouge sur D6 (GPIO 12) pull Down
 Init PWM sortie 2  => Pin D4 module Lolin (
Connecting to WiFi..
Connecting to WiFi..
Connecting to WiFi..
Connecting to WiFi..
192.168.0.110
 Consigne=186
 Consigne=337
 Consigne=532
 Consigne=595
 Consigne=759
 Consigne=913
 Consigne=1023
 Consigne=545
 Consigne=378
 Consigne=154

*/
